# LogBot

LogBot is a bot for asynchronous collective logging and log writing over longer periods of time. The bot operates in a chat environment, from where it saves images, messages and other media files into a document (a web page): the log. Messages and pictures are shared with the other peers in the chat, and with a wider public, creating a form of continuous networked publishing. 

The bot is made by members of Varia and is used hand in hand with event preparations`[1]`, collective research`[2][3]` or as a tool for publishing materials on the go`[4]`. The bot runs on a self-hosted XMPP chat infrastructure, hosted and maintained by members of Varia.

Each of the logs is also available as RSS feed, enabling feed-forwarding or other forms of re-publishing.

`[1]`: https://vvvvvvaria.org/logs/x-y/ X-Y log, in preparation of Plaintext Partyline \
`[2]`: https://vvvvvvaria.org/logs/atnofs-varia/ Collective research log, in the context of the ATNOFS project \
`[3]`: https://vvvvvvaria.org/logs/pub.club/ Pub.club research log, around community publishing initiatives \
`[4]`: https://vvvvvvaria.org/logs/zamopuzo/ Backlog, the making of the streaming infrastructure of Varia 

![](screenshots/logbot-screenshot-1.png) 

![](screenshots/logbot-screenshot-2.png)

## How is LogBot made?

LogBot is small XMPP bot written in Python that is used in group chats. It uses the [xbotlib library](https://git.vvvvvvaria.org/decentral1se/xbotlib) written by [decentral1se](https://git.vvvvvvaria.org/decentral1se).

## Situated tails

- Logbot is part of the AMRO Times publishing workflow, June 2022, Alice Strete & Manetta Berends, <https://art-meets.radical-openness.org/program/amro-times/> + <https://vvvvvvaria.org/amro-times/>
- Logbot is part of the SomeTimes publishing workflow, April 2022, Varia, <https://varia.zone/en/sometimes-af-en-toe.html>
- Bots as Infrapunctures @ Obfuscation Workshop, May 2021, Cristina Cochior & Manetta Berends, <https://3rd.obfuscationworkshop.org/> & <https://bots-as-digital-infrapunctures.dataschool.nl/>
- Logbot v1, Varia XMPP extension 2017-2020, <https://git.vvvvvvaria.org/varia/bots/src/branch/master/logbot>
- Streambot, Varia website extension 2017-2018, <https://git.vvvvvvaria.org/varia/xmpp.streambot>
- Archive bot, Relearn 2017, <https://gitlab.com/relearn/relearn2017/-/tree/master/xmpp-bots/archive-bot>

## How to use LogBot?

```
*Oh dear, logbot is here!*

(You can speak to the bot using `@logbot`, `logbot:` or `logbot`)

<image>: Your image is added to the log.

logbot @help: Print this message

logbot @add <message>: Add a message to the log.

logbot @delete <num>: Delete posts from the log. For example: @logbot @delete 5

logbot @title <string>: Set the title of your log.

logbot @folder <string>: Change the foldername of your log (by default, the roomname of the groupchat is used). Small warning: this changes the URL to your log page.

logbot @style <stylesheet>: Switch to another stylesheet. For example: logbot @style log. Available stylesheets include: timeline (default), float, opentab.

logbot @font <font>: Switch to another font. For example: logbot @font font. Available fonts include: polsku, notcouriersans; or select None to switch back to default serif.

logbot @uptime: To check how long @logbot has been around

@bots: To see who is around :)
```

## Stylesheets

* timeline
* float
* opentab

These can be found in the folder `stylesheets/`.

## Fonts

* polsku
* notcouriersans
* None

## Requirements

- [xbotlib](https://git.vvvvvvaria.org/decentral1se/xbotlib) (`pip3 install xbotlib`)
- [jinja2](https://jinja.palletsprojects.com/) (`pip3 install jinja2`)
